#include <ltdl.h>
#include <aterm2.h>
#include <srts/stratego.h>

typedef ATerm (*strategy_0_0) (ATerm);

ATerm STRI_pointer_to_term(lt_ptr pointer) {
  void** blobdata;

  if((blobdata = (void**) malloc(sizeof(lt_ptr))) == NULL) {
    perror("malloc error for STRI_pointer_to_term");
    return NULL;
  }

  *blobdata = pointer;
  return (ATerm) ATmakeBlob(sizeof(void*), blobdata);
}

lt_ptr STRI_term_to_pointer(ATerm term) {
  void** blobdata;
  lt_ptr pointer;

  if(ATisBlob(term)) {
    if(ATgetBlobSize((ATermBlob) term) != sizeof(lt_ptr)) {
      return NULL;
    }

    blobdata = ATgetBlobData((ATermBlob) term);
    pointer = *blobdata;
  } else {
    pointer = NULL;
  }

  return pointer;
}


/**
 * @param name   Full name of the procedure.
 * @param scount Number of strategy arguments
 * @param scount Number of term arguments
 * @todo Cache the symbols?
 */
ATerm STRI_search_native_procedure_0_2(StrSL sl, ATerm scount, ATerm tcount, ATerm name_term)
{
  const char* name = NULL;
  lt_dlhandle module = NULL;
  lt_ptr sym = NULL;

  if(AT_isString(name_term))
  {
    name = AT_getString(name_term);
  }
  else
  {
    return NULL;
  }

  module = lt_dlhandle_next(NULL);
  while(module != NULL && sym == NULL)
  {
    sym = lt_dlsym(module, name);

    if(sym == NULL)
    {
      module = lt_dlhandle_next(module);
    }
  }

  if(sym != NULL)
  {
    AFun nativefun = ATmakeSymbol("NativeStrategy", 3, ATfalse);
    return (ATerm) ATmakeAppl(nativefun, STRI_pointer_to_term(sym), scount, tcount);
  }
  else
  {
    fprintf(stderr, "Native strategy %s not found.\n", name);
    return NULL;
  }
}

ATerm STRI_dlopen_0_0(StrSL sl, ATerm name_term)
{
  const char* name = NULL;
  lt_dlhandle module;
  lt_dlinit();

  if(AT_isString(name_term))
  {
    name = AT_getString(name_term);
  }
  else
  {
    return NULL;
  }

  SRTS_stratego_initialize = NULL;
  module = lt_dlopenext(name);
  if(module == NULL)
  {
    fprintf(stderr, "%s \n", lt_dlerror());
    return NULL;
  }

  if(SRTS_stratego_initialize != NULL)
  {
    SRTS_stratego_initialize();
  }

  return name_term;
}

ATerm STRI_dllist_0_0(StrSL sl, ATerm t)
{
  lt_dlhandle module = NULL;

  module = lt_dlhandle_next(NULL);
  while(module != NULL)
  {
    fprintf(stderr, "%s\n", lt_dlgetinfo(module) -> filename);
    module = lt_dlhandle_next(module);
  }

  return (ATerm) ATempty;
}
